## flang 20181226

=== runtime/CMakeLists.txt ===
#
# Copyright (c) 2015-2018, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set (RUNTIME_SHARED_DIR ${CMAKE_CURRENT_SOURCE_DIR}/shared)

add_definitions(
 -DMAXCPUS=256 
 -DMAXCPUSL=8 
 -DMAXCPUSR=8 
 -DTARGET_LINUX 
 -DTARGET_LLVM 
 -DLINUX 
 -DPGF90 
 -DPGFLANG
 -DNATIVE_FPCVT
 -DPGI_LITTLE_ENDIAN
 -DINLINE_MEMOPS
)

if( ${TARGET_ARCHITECTURE} STREQUAL "x86_64" )
  add_definitions(
   -DTARGET_X8664
   -DTARGET_LINUX_X8664
  )
elseif( ${TARGET_ARCHITECTURE} STREQUAL "aarch64" )
  add_definitions(
   -DTARGET_LLVM_ARM64
   -DTARGET_LINUX_ARM
  )
elseif( ${TARGET_ARCHITECTURE} STREQUAL "ppc64le" )
  add_definitions(
    -DTARGET_LINUX_POWER
    -DLINUX_POWER
  )
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)

add_subdirectory(ompstub)

add_subdirectory(flangrti)
add_subdirectory(flang)
add_subdirectory(flangmain)

=== lib/scutil/CMakeLists.txt ===
#
# Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

add_library(scutil
 default-fperror.c
 host-fp-folding.c
 int128.c
 legacy-folding-api.c
 legacy-ints.c
 lockfile.c
 path-utils.c
 pgnewfil.c
 cpu-stopwatch.c
)

target_include_directories(scutil
  PRIVATE
  ${FLANG_INCLUDE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

set_target_properties(scutil
  PROPERTIES
  PREFIX ""
  ARCHIVE_OUTPUT_DIRECTORY ${FLANG_LIB_DIR}
  C_STANDARD 99
)

# Clang does not support FENV_ACCESS
set_source_files_properties(
  host-fp-folding.c
  PROPERTIES
  COMPILE_FLAGS "${CMAKE_C_FLAGS} -Wno-unknown-pragmas"
)

=== runtime/ompstub/CMakeLists.txt ===
#
# Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set(OMPSTUB_SRC init_nomp.c  ompstubs.c)

add_flang_library(ompstub_static ${OMPSTUB_SRC})
set_property(TARGET ompstub_static PROPERTY OUTPUT_NAME ompstub)

set(SHARED_LIBRARY TRUE)
add_flang_library(ompstub_shared ${OMPSTUB_SRC})
set_property(TARGET ompstub_shared PROPERTY OUTPUT_NAME ompstub)
set(SHARED_LIBRARY FALSE)

set_target_properties(ompstub_static ompstub_shared
  PROPERTIES
  ARCHIVE_OUTPUT_DIRECTORY ${FLANG_RTE_LIB_DIR}
  )

=== tools/flang1/CMakeLists.txt ===
#
# Copyright (c) 2017-2018, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#


set(FLANG1_SRC_DIR       ${CMAKE_CURRENT_SOURCE_DIR}/flang1exe)
set(FLANG1_DOC_SRC_DIR   ${CMAKE_CURRENT_SOURCE_DIR}/docs)
set(UTILS_SYMTAB_DIR     ${CMAKE_CURRENT_SOURCE_DIR}/utils/symtab)
set(UTILS_AST_DIR        ${CMAKE_CURRENT_SOURCE_DIR}/utils/ast)
set(UTILS_MACHAR_DIR     ${CMAKE_CURRENT_SOURCE_DIR}/utils/machar)
set(UTILS_PARSETABLE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/utils/prstab)

set(UTILS_AST_BIN_DIR        ${CMAKE_CURRENT_BINARY_DIR}/utils/ast)
set(UTILS_SYMTAB_BIN_DIR     ${CMAKE_CURRENT_BINARY_DIR}/utils/symtab)
set(UTILS_MACHAR_BIN_DIR     ${CMAKE_CURRENT_BINARY_DIR}/utils/machar)
set(UTILS_PARSETABLE_BIN_DIR ${CMAKE_CURRENT_BINARY_DIR}/utils/prstab)
set(FLANG1_DOC_BIN_DIR       ${CMAKE_CURRENT_BINARY_DIR}/../../docs/sphinx/flang1)
set(FLANG1_INCLUDE_DIR       ${CMAKE_CURRENT_BINARY_DIR}/include)

include_directories(${FLANG1_INCLUDE_DIR})

option(FLANG_OPENMP_GPU_NVIDIA "Enable OpenMP Accelerator Offload." OFF)
if (FLANG_OPENMP_GPU_NVIDIA)
    add_definitions("-DOMP_OFFLOAD_LLVM")
endif()

add_subdirectory(include)
add_subdirectory(utils)
add_subdirectory(flang1exe)

# Local Variables:
# mode: cmake
# End:

=== tools/flang2/CMakeLists.txt ===
#
# Copyright (c) 2017-2018, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set(FLANG_TOOLS_DIR    ${CMAKE_CURRENT_SOURCE_DIR})
set(FLANG2_SRC_DIR     ${CMAKE_CURRENT_SOURCE_DIR}/flang2exe)
set(FLANG2_DOC_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/docs)
set(UTILS_UPPER_DIR    ${CMAKE_CURRENT_SOURCE_DIR}/utils/upper)
set(UTILS_ILI_DIR      ${CMAKE_CURRENT_SOURCE_DIR}/utils/ilitp)
set(UTILS_ILM_DIR      ${CMAKE_CURRENT_SOURCE_DIR}/utils/ilmtp)
set(UTILS_SYMTAB_DIR   ${CMAKE_CURRENT_SOURCE_DIR}/utils/symtab)
set(UTILS_MACHAR_DIR   ${CMAKE_CURRENT_SOURCE_DIR}/utils/machar)

set(UTILS_SYMTAB_BIN_DIR  ${CMAKE_CURRENT_BINARY_DIR}/utils/symtab)
set(UTILS_ILI_BIN_DIR     ${CMAKE_CURRENT_BINARY_DIR}/utils/ilitp)
set(UTILS_ILM_BIN_DIR     ${CMAKE_CURRENT_BINARY_DIR}/utils/ilmtp)
set(UTILS_MACHAR_BIN_DIR  ${CMAKE_CURRENT_BINARY_DIR}/utils/machar)
set(UTILS_UPPER_BIN_DIR   ${CMAKE_CURRENT_BINARY_DIR}/utils/upper)
set(FLANG2_DOC_BIN_DIR    ${CMAKE_CURRENT_BINARY_DIR}/../../docs/sphinx/flang2)
set(FLANG2_INCLUDE_DIR    ${CMAKE_CURRENT_BINARY_DIR}/include)

include_directories(${FLANG2_INCLUDE_DIR})

if( ${TARGET_OS} STREQUAL "Linux" )
  if( ${TARGET_ARCHITECTURE} STREQUAL "x86_64" )
    set(X86_64 ON)
    set(LINUX86 ON)
  endif()
endif()

option(FLANG_OPENMP_GPU_NVIDIA "Enable OpenMP Accelerator Offload." OFF)
if (FLANG_OPENMP_GPU_NVIDIA)
    add_definitions("-DOMP_OFFLOAD_LLVM")
endif()

add_subdirectory(include)
add_subdirectory(utils)
add_subdirectory(flang2exe)

# Local Variables:
# mode: cmake
# End:

=== utils/errmsg/CMakeLists.txt ===
#
# Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

add_executable(errmsggen
  errmsg.cpp
  )

=== flang-driver/tools/scan-build/CMakeLists.txt ===
option(CLANG_INSTALL_SCANBUILD "Install the scan-build tool" ON)

include(GNUInstallDirs)

if (WIN32 AND NOT CYGWIN)
  set(BinFiles
        scan-build
        scan-build.bat)
  set(LibexecFiles
        ccc-analyzer
        c++-analyzer
        ccc-analyzer.bat
        c++-analyzer.bat)
else()
  set(BinFiles
        scan-build)
  set(LibexecFiles
        ccc-analyzer
        c++-analyzer)
  if (APPLE)
    list(APPEND BinFiles
           set-xcode-analyzer)
  endif()
endif()

set(ManPages
      scan-build.1)

set(ShareFiles
      scanview.css
      sorttable.js)


if(CLANG_INSTALL_SCANBUILD)
  foreach(BinFile ${BinFiles})
    add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/bin/${BinFile}
                       COMMAND ${CMAKE_COMMAND} -E make_directory
                         ${CMAKE_BINARY_DIR}/bin
                       COMMAND ${CMAKE_COMMAND} -E copy
                         ${CMAKE_CURRENT_SOURCE_DIR}/bin/${BinFile}
                         ${CMAKE_BINARY_DIR}/bin/
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/bin/${BinFile})
    list(APPEND Depends ${CMAKE_BINARY_DIR}/bin/${BinFile})
    install(PROGRAMS bin/${BinFile} DESTINATION bin)
  endforeach()

  foreach(LibexecFile ${LibexecFiles})
    add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/libexec/${LibexecFile}
                       COMMAND ${CMAKE_COMMAND} -E make_directory
                         ${CMAKE_BINARY_DIR}/libexec
                       COMMAND ${CMAKE_COMMAND} -E copy
                         ${CMAKE_CURRENT_SOURCE_DIR}/libexec/${LibexecFile}
                         ${CMAKE_BINARY_DIR}/libexec/
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/libexec/${LibexecFile})
    list(APPEND Depends ${CMAKE_BINARY_DIR}/libexec/${LibexecFile})
    install(PROGRAMS libexec/${LibexecFile} DESTINATION libexec)
  endforeach()

  foreach(ManPage ${ManPages})
    add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/man1/${ManPage}
                       COMMAND ${CMAKE_COMMAND} -E make_directory
                         ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/man1
                       COMMAND ${CMAKE_COMMAND} -E copy
                         ${CMAKE_CURRENT_SOURCE_DIR}/man/${ManPage}
                         ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/man1/
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/man/${ManPage})
    list(APPEND Depends ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/man1/${ManPage})
    install(PROGRAMS man/${ManPage} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
  endforeach()

  foreach(ShareFile ${ShareFiles})
    add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/share/scan-build/${ShareFile}
                       COMMAND ${CMAKE_COMMAND} -E make_directory
                         ${CMAKE_BINARY_DIR}/share/scan-build
                       COMMAND ${CMAKE_COMMAND} -E copy
                         ${CMAKE_CURRENT_SOURCE_DIR}/share/scan-build/${ShareFile}
                         ${CMAKE_BINARY_DIR}/share/scan-build/
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/share/scan-build/${ShareFile})
    list(APPEND Depends ${CMAKE_BINARY_DIR}/share/scan-build/${ShareFile})
    install(FILES share/scan-build/${ShareFile} DESTINATION share/scan-build)
  endforeach()

  add_custom_target(scan-build ALL DEPENDS ${Depends})
  set_target_properties(scan-build PROPERTIES FOLDER "Misc")
endif()

=== flang-driver/unittests/Sema/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Support
  )

add_clang_unittest(SemaTests
  ExternalSemaSourceTest.cpp
  CodeCompleteTest.cpp
  )

target_link_libraries(SemaTests
  PRIVATE
  clangAST
  clangBasic
  clangFrontend
  clangParse
  clangSema
  clangTooling
  )

=== tools/flang1/flang1exe/CMakeLists.txt ===
#
# Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set(SOURCES
  accpp.c
  assem.c
  ast.c
  astdf.c
  astout.c
  bblock.c
  comm.c
  commdf.c
  commgen.c
  comminvar.c
  commopt.c
  datadep.c
  detect.c
  dinit.c
  dinitutl.c
  dist.c
  dpm_out.c
  dtypeutl.c
  dummy.c
  dump.c
  exterf.c
  fenddf.c
  fgraph.c
  findloop.c
  flow.c
  fpp.c
  func.c
  hlvect.c
  hpfutl.c
  induc.c
  inliner.c
  interf.c
  invar.c
  iterat.c
  listing.c
  lower.c
  lowerchk.c
  lowerexp.c
  lowerilm.c
  lowersym.c
  lz.c
  main.c
  module.c
  optdf.c
  optimize.c
  optutil.c
  outconv.c
  parser.c
  pointsto.c
  psemant.c
  psemant2.c
  psemant3.c
  psemantio.c
  psemsmp.c
  pstride.c
  redundss.c
  rest.c
  rte.c
  scan.c
  scopestack.c
  semant.c
  semant2.c
  semant3.c
  semantio.c
  semast.c
  semfin.c
  semfunc.c
  semfunc2.c
  semgnr.c
  semsmp.c
  semsym.c
  semtbp.c
  semutil.c
  semutil2.c
  symacc.c
  symtab.c
  symutl.c
  transfrm.c
  version.c
  xref.c
  vsub.c
  )

set(COMMON_DEFS
  MMD
  PGF90
  )

set_source_files_properties(accpp.c PROPERTIES COMPILE_FLAGS -Wno-comment)
set_source_files_properties(fpp.c PROPERTIES COMPILE_FLAGS -Wno-comment)

set(INCLUDE_DIRS
  ${FLANG_INCLUDE_DIR}
  ${UTILS_SYMTAB_BIN_DIR}     # Symbol table and ILM headers
  ${UTILS_MACHAR_BIN_DIR}     # Machar headers
  ${UTILS_AST_BIN_DIR}        # AST headers
  ${UTILS_PARSETABLE_BIN_DIR} # Parser headers
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${TOOLS_SHARED_DIR}
  )

set(COMPILE_OPTS
  -std=c11
  )

add_flang_executable(flang1
  ${SOURCES} ${SHARED_SOURCES}
  )

target_compile_definitions(flang1
  PRIVATE
  ${COMMON_DEFS}
  )

add_dependencies(flang1
  gen_frontend_symtab        # Symbol table
  gen_frontend_symini        # Symini (symbol table) ILM IR for lowering
  gen_frontend_machar        # Machar
  gen_frontend_ast           # AST
  gen_frontend_error_headers # Error message headers
  gen_frontend_parsetable    # Parser headers
  )

if (FLANG_INCLUDE_DOCS)
  add_dependencies(flang1_gen_sphinx_docs
    flang1
    )
endif()

target_include_directories(flang1
  PRIVATE
  ${INCLUDE_DIRS}
  )

target_compile_options(flang1
  PRIVATE
  ${COMPILE_OPTS}
  )

target_link_libraries(flang1
  flangArgParser
  ${FLANG_LIB_DIR}/scutil.a
  -lm
  )

# Install flang1 executable
install(TARGETS flang1
  RUNTIME DESTINATION bin)

# Local Variables:
# mode: cmake
# End:

=== tools/flang1/include/CMakeLists.txt ===

#
# Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Generate platform header

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/platform.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/platform.h
  @ONLY)

# Generate error message headers

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/errmsgdf.h
         ${CMAKE_CURRENT_BINARY_DIR}/errmsg.n
         ${FLANG1_DOC_BIN_DIR}/errmsg.rst
  COMMAND ${CMAKE_BINARY_DIR}/bin/errmsggen ${FLANG_INCLUDE_DIR}/Error/errmsg-in.n
                                            ${FLANG_INCLUDE_DIR}/Error/errmsg-common.n
                                            ${FLANG_INCLUDE_DIR}/Error/errmsg-ipa.n
                                         -o ${CMAKE_CURRENT_BINARY_DIR}/errmsgdf.h
                                         -e ${CMAKE_CURRENT_BINARY_DIR}/errmsg.n
                                         -s ${FLANG1_DOC_BIN_DIR}/errmsg.rst
  DEPENDS errmsggen ${FLANG_INCLUDE_DIR}/Error/errmsg-in.n
                    ${FLANG_INCLUDE_DIR}/Error/errmsg-common.n
                    ${FLANG_INCLUDE_DIR}/Error/errmsg-ipa.n
  )

add_custom_target(gen_frontend_error_headers
  SOURCES ${CMAKE_CURRENT_BINARY_DIR}/errmsgdf.h
          ${CMAKE_CURRENT_BINARY_DIR}/errmsg.n
          ${FLANG1_DOC_BIN_DIR}/errmsg.rst
  )

# Local Variables:
# mode: cmake
# End:

=== tools/flang2/flang2exe/CMakeLists.txt ===
#
# Copyright (c) 2017-2018, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

if( ${TARGET_ARCHITECTURE} STREQUAL "x86_64" )
  set(ARCH_DEP_FILES
    x86_64-Linux/ll_abi.cpp
  )
elseif( ${TARGET_ARCHITECTURE} STREQUAL "aarch64" )
  set(ARCH_DEP_FILES
      aarch64-Linux/ll_abi.cpp
  )
elseif( ${TARGET_ARCHITECTURE} STREQUAL "ppc64le" )
  set(ARCH_DEP_FILES
    ppc64le-Linux/ll_abi.cpp
  )
endif()

set(SOURCES
  ${ARCH_DEP_FILES}
  bihutil.cpp
  dinitutl.cpp
  dinit.cpp
  dtypeutl.cpp
  fenddf.cpp
  ilmutil.cpp
  listing.cpp
  mwd.cpp
  semsym.cpp
  semutil0.cpp
  symtab.cpp
  symacc.cpp
  upper.cpp
  xref.cpp
  expreg.cpp
  exputil.cpp
  regutil.cpp
  expdf.cpp
  ili-rewrite.cpp
  ilidf.cpp
  iliutil.cpp
  iltutil.cpp
  expand.cpp
  expatomics.cpp
  expsmp.cpp
  exp_ftn.cpp
  exp_fvec.cpp
  exp_rte.cpp
  outliner.cpp
  rmsmove.cpp
  scope.cpp
  rbtree.cpp
  ll_dbgutl.cpp
  dwarf_names.cpp
  llassem.cpp
  llassem_common.cpp
  asm_anno.cpp
  main.cpp
  version.cpp
  cgmain.cpp
  fastset.cpp
  lldebug.cpp
  llutil.cpp
  ll_ftn.cpp
  ll_structure.cpp
  ll_write.cpp
  ll_builder.cpp
  llopt.cpp
  llsched.cpp
  machreg.cpp
  kmpcutil.cpp
  verify.cpp
  ompaccel.cpp
  tgtutil.cpp
  )

set(COMMON_DEFS
  MMD
  NOVECTORIZE
  IN_FLANG2
  )

set(INCLUDE_DIRS
  ${TOOLS_SHARED_DIR}
  ${FLANG_INCLUDE_DIR}
  ${FLANG_SOURCE_DIR}/lib/scutil
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/${TARGET_ARCHITECTURE}-${TARGET_OS}
  ${UTILS_SYMTAB_BIN_DIR}        # Symbol table headers
  ${UTILS_ILI_BIN_DIR}           # ILI IR headers
  ${UTILS_ILM_BIN_DIR}           # ILM IR headers
  ${UTILS_MACHAR_BIN_DIR}        # ILM IR headers
  ${UTILS_UPPER_BIN_DIR}         # `Upper' headers
  ${UTILS_SHARED_DIR}
  )

set(SHARED_SOURCES
  ${SHARED_SOURCES}
  ${LIB_SOURCE_DIR}/ADT/hash.c
  ${LIB_SOURCE_DIR}/ArgParser/arg_parser.c
  ${LIB_SOURCE_DIR}/ArgParser/debug_action.c
  ${LIB_SOURCE_DIR}/ArgParser/xflag.c
  )


foreach(FILE ${SHARED_SOURCES})
  get_filename_component(TOFILE ${FILE} NAME)
  add_custom_command(OUTPUT ${TOFILE}pp 
    COMMAND ${CMAKE_COMMAND} -E create_symlink ${FILE} ${TOFILE}pp
    MAIN_DEPENDENCY ${FILE})
  set(SHARED_CPP_SOURCES ${SHARED_CPP_SOURCES} ${TOFILE}pp)
endforeach()

add_flang_executable(flang2
  ${SOURCES} ${SHARED_CPP_SOURCES}
  )

target_compile_definitions(flang2
  PRIVATE
  ${COMMON_DEFS}
  )

target_compile_options(flang2
  PRIVATE
  ${COMPILE_OPTS}
  )

target_link_libraries(flang2
  flangArgParser
  ${FLANG_LIB_DIR}/scutil.a
  -lm
  )

add_dependencies(flang2
  gen_backend_error_headers # Error message headers
  gen_backend_symtab        # Symbol table headers
  gen_backend_symini        # Symbol table (symini) headers
  gen_backend_ili           # ILI IR headers
  gen_backend_ilm           # ILM IR headers
  gen_backend_machar        # Machar headers
  gen_backend_upper         # `Upper' headers
  )

if (FLANG_INCLUDE_DOCS)
  add_dependencies(flang2
    gen_sphinx_docs
    )
endif()

target_include_directories(flang2
  PRIVATE
  ${INCLUDE_DIRS}
  )

# Install flang2 executable
install(TARGETS flang2
  RUNTIME DESTINATION bin)

# Local Variables:
# mode: cmake
# End:

=== tools/flang2/include/CMakeLists.txt ===
#
# Copyright (c) 2017, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Generate platform header

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/platform.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/platform.h
  @ONLY)

# Generate error message headers

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/errmsgdf.h
         ${CMAKE_CURRENT_BINARY_DIR}/new_errmsg.n
         ${FLANG2_DOC_BIN_DIR}/errmsg.rst
  COMMAND ${CMAKE_BINARY_DIR}/bin/errmsggen ${FLANG_INCLUDE_DIR}/Error/errmsg-accel.n
                                            ${FLANG_INCLUDE_DIR}/Error/errmsg-common.n
                                            ${FLANG_INCLUDE_DIR}/Error/errmsg-hammer.n
                                            ${FLANG_INCLUDE_DIR}/Error/errmsg.n
                                         -o ${CMAKE_CURRENT_BINARY_DIR}/errmsgdf.h
                                         -e ${CMAKE_CURRENT_BINARY_DIR}/new_errmsg.n
                                         -s ${FLANG2_DOC_BIN_DIR}/errmsg.rst
  DEPENDS errmsggen ${FLANG_INCLUDE_DIR}/Error/errmsg-accel.n
                    ${FLANG_INCLUDE_DIR}/Error/errmsg-common.n
                    ${FLANG_INCLUDE_DIR}/Error/errmsg-hammer.n
                    ${FLANG_INCLUDE_DIR}/Error/errmsg.n
  )

add_custom_target(gen_backend_error_headers
  SOURCES ${CMAKE_CURRENT_BINARY_DIR}/errmsgdf.h
          ${CMAKE_CURRENT_BINARY_DIR}/new_errmsg.n
          ${FLANG2_DOC_BIN_DIR}/errmsg.rst
  )

# Local Variables:
# mode: cmake
# End:

=== debian/changelog ===
flang (20181226-2) unstable; urgency=medium

  * Patch for kfreebsd to match llvm-7-dev changes
  * mv flang -> flang-7 and add symlink
  * Update README.Debian

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Feb 2019 09:21:29 +0000

flang (20181226-1) unstable; urgency=medium

  * New upstream release. Closes: #909463
   - Add flang-driver/LICENSE.txt to d/copyright
   - patch needed for libpgmath CMPLX collision with g++
  * Two stage Build: first stage with gfortran
      second stage with flang
  * Add $fmoddir to standard include path
  * Place system mod files in $fmoddir
  * Standards-Version: 4.3.0

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Jan 2019 00:18:12 +0000

flang (20180921-1) unstable; urgency=medium

  * Initial release. 
    This build has OpenMP and IEEE exceptions support,
    LLVMPolly support disabled

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Dec 2018 13:50:03 +0000

=== debian/control ===
Source: flang
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends:  debhelper (>= 10),
  dh-fortran-mod,
  chrpath,
  gawk,
  zlib1g-dev,
  cmake,
  llvm-7,
  llvm-7-dev,
  libomp-7-dev,
  llvm-7-tools,
  gfortran
Standards-Version: 4.3.0
Homepage: https://github.com/flang-compiler/flang
Vcs-Browser: https://salsa.debian.org/mckinstry/flang.git
Vcs-Git: https://salsa.debian.org/mckinstry/flang.git

Package: flang-7
Architecture: any
Provides: fortran-compiler
Fortran-Mod: ${Fortran-Mod}
Depends: ${misc:Depends}, ${shlibs:Depends}, libflang0d-7 ( = ${binary:Version}), libflang-dev ( = ${binary:Version})
Description: Fortran compiler front-end for LLVM
 This is a Fortran compiler using LLVM.

Package: libflang0d-7
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Runtime libraries for the flang Fortran compiler
 Flang is a Fortran compiler for the LLVM toolchain.
 .
 This provides the flang runtime libraries.

Package: libflang-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libflang0d-7 (= ${binary:Version})
Description: flang library - Development package.
 Flang is a Fortran compiler for the LLVM toolchain.
 .
 This provides the static libraries and headers for Extension writing.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

UPSTREAM_VERSION=20181226

BUILDDIR=$(CURDIR)/debian/build
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libflang-dev.install libflang0d-7.install flang-7.install

%:
	dh $@ --buildsystem=cmake  --with=fortran_mod --builddirectory=$(BUILDDIR)

override_dh_auto_clean:
	dh_clean
	rm -rf $(BUILDDIR)
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	# Configuration and build are interleaved, so no configure here
	mkdir -p $(BUILDDIR)/runtime/libpgmath $(BUILDDIR)/flang-driver $(BUILDDIR)/stage2
	# Bug in install CMake code. Need these
	mkdir -p $(BUILDDIR)/include $(BUILDDIR)/stage2/include

override_dh_auto_build:
	(cd $(BUILDDIR)/runtime/libpgmath && cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DLIBPGMATH_LLVM_LIT_EXECUTABLE=/usr/lib/llvm-7/build/utils/lit/lit.py \
	    ../../../../runtime/libpgmath && \
	    $(MAKE) VERBOSE=1 install DESTDIR=$(CURDIR)/debian/tmp )
	( cd $(BUILDDIR)/flang-driver && cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DLINK_POLLY_INTO_TOOLS=False \
	    -DLLVM_CONFIG=/usr/lib/llvm-7/bin/llvm-config \
	    ../../../flang-driver &&  \
	    $(MAKE) VERBOSE=1 DESTDIR=$(CURDIR)/debian/tmp )
	# Stage 1. Built with gfortran
	(cd $(BUILDDIR) && cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DCMAKE_Fortran_COMPILER=/usr/bin/gfortran \
	    -DCMAKE_Fortran_COMPILER_ID=gfortran \
	    -DLLVM_CONFIG=/usr/lib/llvm-7/bin/llvm-config \
	    -DFLANG_LIBOMP=$(LIBDIR)/libomp5.so	\
	    -DLIBPGMATH=$(CURDIR)/debian/tmp/usr/lib/libpgmath.so \
	    ../.. && \
	    $(MAKE) VERBOSE=1 DESTDIR=$(CURDIR)/debian/tmp-stage1 )
	# Stage 2. Built with flang
	(cd $(BUILDDIR)/stage2 && PATH=$(BUILDDIR)/debian/build/bin:$(PATH) cmake \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DCMAKE_Fortran_COMPILER=$(BUILDDIR)/flang-driver/bin/flang \
	    -DCMAKE_Fortran_COMPILER_ID=flang \
	    -DLLVM_CONFIG=/usr/lib/llvm-7/bin/llvm-config \
	    -DFLANG_LIBOMP=$(LIBDIR)/libomp5.so	\
	    -DLIBPGMATH=$(CURDIR)/debian/tmp/usr/lib/libpgmath.so \
	    ../../.. && \
	    $(MAKE) VERBOSE=1 DESTDIR=$(CURDIR)/debian/tmp )

override_dh_auto_install:
	dh_auto_install --builddirectory=$(BUILDDIR)/runtime/libpgmath
	# Do in install scripts; fails within pdebuild, why ?
	( cd debian/build/stage2 && make VERBOSE=1 install DESTDIR=$(CURDIR)/debian/tmp )
	chrpath -d debian/tmp/usr/lib/*.so*
	cp -L $(BUILDDIR)/flang-driver/bin/clang-7 debian/tmp/usr/bin/flang-7
	chrpath -d debian/tmp/usr/bin/flang*
